#ifndef DEFS_H_INCLUDED
#define DEFS_H_INCLUDED

#define GEN_STACK		1400
#define MAX_PLY			32
#define HIST_STACK		600
#define HASH_SIZE		1048576

#define XBOARD			1
#define PERFT			2
#define ITERATIVE		3

#define	hashfEXACT		0
#define	hashfALPHA		1
#define	hashfBETA		2
#define valUNKNOWN		12666

typedef struct piece_entry_structure {
    int             piece_value;/* pawn=1, knight=2, king=3, bishop=5, rook=6 and queen=7 */
    int             piece_location;     /* where the piece is on the board */
    /* other things to be added later */
}   piece_entry;

typedef struct move {
    int             from;
    int             to;
    int             piece_promote;
    int             ep_location_created;
    int             ep_victim_location;
    short int       castle;
    int             score;
}   move;

typedef struct move_hist {
    int             from;
    int             to;
    int             capture;
    int             piece_promote;
    unsigned char   board_status;
    int             ep_location;
    int             ep_victim_location;
    short int       castle;
    int             fifty;
    unsigned        hash;
}   move_hist;

typedef struct HASHE {
    int             key;
    int             depth;
    int             flags;
    int             value;
    move            best;
}   HASHE;

extern int      convertAlgy(char *file, char *rank);
extern int      evaluate(void);
extern int      evaluatePiece(int value);
extern int      getTime(void);
extern int      hash_rand(void);
extern int      it_main(void);
extern int      NegaMax(int depth, int alpha, int beta);
extern int      NegaMaxQuiescent(int alpha, int beta);
extern int      NegaScout(int depth, int alpha, int beta);
extern int      parse_move(char *s);
extern int      perft_main(void);
extern int      ProbeHash(int depth, int alpha, int beta);
extern int      x_main(void);
extern short    attacked(int target);
extern short    make_move(struct move moveDetails);
extern short    take_back(void);
extern void     add_move(int from, int to);
extern void     add_move_capture(int from, int to);
extern void     add_move_capture_promote(int from, int to);
extern void     add_move_castle(int from, int to, short castle);
extern void     add_move_creating_ep(int from, int to, int ep_location_created);
extern void     add_move_ep_capture(int from, int to, int ep_victim_location);
extern void     add_move_promote(int from, int to);
extern void     convertLocation(int location, char *algy);
extern void     convertPiece(int piece, char *pieceAlgy);
extern void     convertPiece2(int piece, char *pieceAlgy);
extern void     generate_captures(void);
extern void     generate_moves(void);
extern void     init_hash(void);
extern void     Perft(int depth);
extern void     print_result(void);
extern void     readFEN(char *gen);
extern void     RecordHash(int depth, int value, int flags);
extern void     set_hash(void);
extern void     showBoard(void);
extern void     showFullBoard(void);
extern void     showGenMoves(void);
extern void     showHistory(void);
extern void     showPieces(void);
extern void     showPV(void);
extern void     sort(int fromMove);
extern void     sort_pv(void);
extern void     terminate(void);
extern void     think(void);

#endif          /* DEFS_H_INCLUDED */
